/*   Copyright (c) 2015 Boulder Real Time Technologies, Inc.
 *
 *   This software module is wholly owned by Boulder Real Time
 *   Technologies, Inc. Any use of this software module without
 *   express written permission from Boulder Real Time Technologies,
 *   Inc. is prohibited.
 */

#ifndef QDSCONNECTION_H
#define QDSCONNECTION_H

#include <iostream>
#include <memory>
#include <stdexcept>
#include <QObject>
#include <QException>

#include "db.h"

class QDbptr;
class QDsResponse;
class QDsServer;

class QDsConnection : public QObject
{
	Q_OBJECT

	public:
				QDsConnection( QString serverName );
				QDsConnection( QString serverName, QString databaseName, QString perm );
				~QDsConnection( void );

		QDbptr*		openDatabase( QString databaseName, QString perm );
		void		closeDatabase( void );
		bool		databaseIsOpen( void );
		QDbptr*		getQDbptr( void );
		QString		getServerName( void );
		QString		getLaunchDbName( void );
		std::shared_ptr<QDsResponse>	request( QDbptr*, QString request, QVariantList args );
		std::shared_ptr<QDsResponse>	request( QDbptr*, QString request );

	signals:
		
		void		databaseClosed( void );

	private:
		
		QString		m_serverName;
		QString		m_launchDbName;
		Dbptr		m_db;
		QDsServer*	m_localServer; 		// SCAFFOLD will be some kind of QDataStream or QIODevice ultimately
};

#endif
