/*   Copyright (c) 2015 Boulder Real Time Technologies, Inc.
 *
 *   This software module is wholly owned by Boulder Real Time
 *   Technologies, Inc. Any use of this software module without
 *   express written permission from Boulder Real Time Technologies,
 *   Inc. is prohibited.
 */

#ifndef QDSSERVER_H
#define QDSSERVER_H

#include <iostream>
#include <memory>
#include <stdexcept>
#include <QObject>
#include <QException>

class QDbptr;
class QDsResponse;

class QDsServer : public QObject
{
	Q_OBJECT

	public:
					QDsServer( void );
					~QDsServer( void );

		std::shared_ptr<QDsResponse>	process( QDbptr*, QString request, QVariantList args );

	private:
		
		void 			setProcessError( std::shared_ptr<QDsResponse> response, QDbptr* qdb, QString request, QString message, bool includeElogStack = false );
			
};

#endif
